/*----------------------------------------------------------------------------
 *      Name:    usbvendreq.h
 *      Purpose: 
 */


#define MSG_SZ 256  // *** Max Control Message data packet size allowed ***
#define USB_SER_SZ 256  // *** Usb Serial Buffer size ***
//#define USB_SERIAL_RETY_TIMOUT 600 // Value in milliseconds


 /* USB vendor requests 

	gets are even
	sets are odd
*/
enum VENDREQ
{
	VENDREQ_NONE								= 0x00,	 
	VENDREQ_GET_STATUS_STRING		= 0xCA,
	VENDREQ_GET_SOFTVERSION			= 0xCC,
	VENDREQ_GET_HARDVERSION			= 0xCE,

 	VENDREQ_SET_COMMAND						= 0xA0,
	VENDREQ_GET_RESPONSE					= 0xA1,
 	VENDREQ_GET_RESPONSEPENDING		= 0xA2,
 	VENDREQ_SET_RESPONSERECEIVED	= 0xA3
} ;

extern volatile unsigned int UsbInPending;
extern volatile unsigned int UsbOutPending;

extern unsigned char myUsbOutBuf[64];
extern unsigned char myUsbOutTmpBuf[64];
extern unsigned char myUsbInBuf[64];
extern unsigned char myUsbInTmpBuf[64];

extern unsigned int VendorRequestOutHandler (void);
extern unsigned int VendorRequestInSetupHandler (void);
extern unsigned int VendorRequestOutSetupHandler(void);
extern unsigned int VendorRequestInHandler(void);

extern char hardwareVersion[];
extern char softwareVersion[];
extern char boardID[];
extern char deviceName[];

