#define BE_MAX_CMD_RSP_SIZE 		80
#define BE_MAX_CMD_SIZE            64

#define CR_KEY	0x0D	// Carriage return
#define NL_KEY	0x0A	// New Line
#define BS_KEY	0x08	// Backspace

typedef struct
{
	char cmd[BE_MAX_CMD_SIZE];
	int maxArgs;
	void (*cmdHandler)(void);
} VERIFY_CMDS;

typedef struct {
	unsigned char id;
	void (*cmdHandler)(void);
} OXXIUS_COMMANDS;

typedef struct {
	char resp[30];
} DL_Q_RESPONSE;

typedef struct {
	char resp[30];
} AL_RESPONSE;

int backEndHandler(void);
void mfrModeResponseHandler(void);

char* getFcFromPrompt(char *inString);
void clearGlobalResponseBuffers(void);

extern void backEndparser(char myPort,char myOriginPort, char *myBuffer, unsigned char myMsgSize);
extern void backEndparserOx(char myPort,char myOriginPort, char *myBuffer, unsigned char myMsgSize);
extern void clearGlobalResponseBuffers(void);

//Used only in backEndParser.c where declared
void BEgeneralBackHandler(unsigned char myLength);
void emptyResponseHandler(void);
void BEcHandler(void);
void BEq_ccHandler(void);
void BEdelayHandler(void);
void BEepcHandler(void);
void BEleHandler(void);
void BElpHandler(void);
void BEpromptHandler(void);
void BEtecHandler(void);
void BEvobtsHandler(void);
void BEpulHandler(void);
void BEppHandler(void);
void BEq_bptHandler(void);
void BEq_cHandler(void);
void BEq_delayHandler(void);
void BEq_epcHandler(void);
void BEq_fcHandler(void);
void BEq_fdHandler(void);
void BEq_fpHandler(void);
void BEq_fvHandler(void);
void BEq_ilHandler(void);
void BEq_lcHandler(void);
void BEq_leHandler(void);
void BEq_lhHandler(void);
void BEq_liHandler(void);
void BEq_lpHandler(void);
void BEq_lpsHandler(void);
void BEq_lwHandler(void);
void BEq_maxpHandler(void);
void BEq_obtHandler(void);
void BEq_obtsHandler(void);
void BEq_rpHandler(void);
void BEq_tecHandler(void);
void BEq_ppHandler(void);
void BEq_pulHandler(void);
void BEq_op1Handler(void);
void BEq_op2Handler(void);
void BEq_op3Handler(void);
void BEq_op4Handler(void);
void ox_BE_dlOnHandler(void);
void ox_BE_dlOffHandler(void);
void ox_BE_invalHandler(void);
void ox_BEq_dlfcHandler(void);
void ox_BEq_dlfdHandler(void);
void ox_BEq_btHandler(void);
void ox_BEq_dlHandler(void);
void ox_BEq_etHandler(void);
void ox_BEq_ipHandler(void);
void ox_BEq_tmHandler(void);
void ox_BEq_veHandler(void);










