//circular_queue.h
//#include "system.h"
#define MAX_Q_BUF_SIZE	64

typedef struct
{
	unsigned char *qPtrHead[2];
	unsigned char *qPtrTail[2];
	unsigned char queue[2][MAX_Q_BUF_SIZE];
	
} Q_CONFIG;	

typedef enum {
	Q_READ = 0,
	Q_WRITE
} Q_ACCESS;

typedef enum {
	USB_Q = 0,
	UART1_Q,
	UART2_Q,
	UART3_Q,
	UART4_Q,
	EXT_UART_Q,
	END_OF_QUEUES	//marks end of queues when indexing queues
} Q_STREAM;
 
typedef enum {
	IN_Q = 0, //The input queue
	OUT_Q     //The output queue
} Q_TYPE;

extern void qInit(void);	// initialize all of the queues
extern void writeQ(Q_STREAM myQ, Q_TYPE myQType, unsigned char *myData, unsigned char mySize);	// Store a bytes to the specified queue if there is room in the queue
extern void readQ(Q_STREAM myQ, Q_TYPE myQType, unsigned char *myData, unsigned char mySize);	// read bytes from the specified queue if there is data																																							// in the queue, This does NOT Flush the data from  the queue
extern void flushQ(Q_STREAM myQ, Q_TYPE myQType, unsigned char mySize);	// flush bytes from the specified queue if there is data in the queue
extern unsigned char qFullIndicator(Q_STREAM myQ, Q_TYPE myQType);	// the number of bytes that have been written and can be read from the queue
extern unsigned char qEmptyIndicator(Q_STREAM myQ, Q_TYPE myQType);



