//config.h

// System Configuration Defaults.
#define EE_DEF_VERSION  0x01
#define EE_DEF_ECHO 1
#define EE_DEF_PROMPT 1

//System Calibration Defaults.
#define EE_CAL_VER 1.0
#define EE_DEF_LSR_TYPES 0x0000 //No Laser Type Established
#define EE_DEF_MAX_PWR 0
#define EE_DEF_NOM_PWR 0
#define EE_DEF_NOM_WAVE 0
#define EE_DEF_PART_NUM "0000000000"
#define EE_DEF_SER_NUM "0000000000"
#define EE_DEF_BM_SHAPE "C"
	
extern short isCalImageGood;
extern short isSysCfgImageGood;

// EEPROM image areas
typedef enum {
	EE_AREA_SYS_CFG = 0,
	EE_AREA_CAL,
	EE_AREA_END				// DO NOT REMOVE!! USED TO specify the last entry
} EE_AREA_TYPE;

// this system configuration shadow registers MUST match the locations and sizes of the "EEPROM Memory Image"!
typedef struct {
	unsigned short version;
	unsigned char Echo;
	unsigned char Prompt;
} SYS_CFG_SHADOW_REG;

// this system configuration shadow registers MUST match the locations and sizes of the "EEPROM Memory Image"!
typedef struct {
	double calVersion;
	short laserTypeA;
	short laserTypeB;
	short laserTypeC;
	short laserTypeD;
	//Added to make other mfr's lasers maintain Stradus cmd set
	double maxPwrLsr_A;
	short nomLsrPwr_A;
	short nomWaveLen_A;
	char lsrPartNum_A[11];
	char lsrSerialNum_A[11];
	char lsrBeamShape_A[4];
	double maxPwrLsr_B;
	short nomLsrPwr_B;
	short nomWaveLen_B;
	char lsrPartNum_B[11];
	char lsrSerialNum_B[11];
	char lsrBeamShape_B[4];
	double maxPwrLsr_C;
	short nomLsrPwr_C;
	short nomWaveLen_C;
	char lsrPartNum_C[11];
	char lsrSerialNum_C[11];
	char lsrBeamShape_C[4];
	double maxPwrLsr_D;
	short nomLsrPwr_D;
	short nomWaveLen_D;
	char lsrPartNum_D[11];
	char lsrSerialNum_D[11];
	char lsrBeamShape_D[4];
} CAL_SHADOW_REG;

typedef struct{
	unsigned char Bypass;
	char A_qFC[6];
	char B_qFC[6];
	char C_qFC[6];
	char D_qFC[6];
} VOLATILE_REGISTERS;

extern void sysCfgInit(void);
extern void saveSysCfgDelta(EE_AREA_TYPE);
extern SYS_CFG_SHADOW_REG sysCfgShadowRegs;
extern CAL_SHADOW_REG calShadowRegs;
extern void forceSysCfgDefaults(void);





