#include "p24FJ256GB106.h"

#include "init.h"

void initBoard()
{
	assignPins();
	I2C2CONbits.I2CEN=0; //Disable I2C 2 module
	setTRISTATE();
}

void assignPins()
{
	//IOLOCK SET/CLR Sequence
	//1. Write 46h to OSCCON<7:0>.
	//2. Write 57h to OSCCON<7:0>.
	//3. Clear (or set) IOLOCK as a single operation.
	OSCCON=0x46;
	OSCCON=0x57;
	OSCCONbits.IOLOCK=0;

	//Inputs:
	//External I2C UART IRQ Interrupt Pin Assigned as INT1 on PIC
	//Pin 42, RTCC/DMLN/RP2/CN53/RD8
	RPINR0bits.INT1R=2;
	//U1RX
	RPINR18bits.U1RXR= 25;    //Pin 52, RD4
	//U2RX
	RPINR19bits.U2RXR= 23;    //Pin50, RD2
	//U3RX
	RPINR17bits.U3RXR= 17;    //Pin32, RF5
	//U4RX
	RPINR27bits.U4RXR= 29;    //Pin30, RB15

	//Outputs:
	//U1TX ==3 //Pin 53, RP20, RD5
	RPOR10bits.RP20R=3;
	//U2TX ==5 //Pin 51, RP22, RD3
	RPOR11bits.RP22R=5;
	//U3TX ==28 //Pin 31, RP10, RF4
	RPOR5bits.RP10R=28;
	//U4TX ==30 //Pin 29, RP14, RB14
	RPOR7bits.RP14R=30;

	OSCCON=0x46;
	OSCCON=0x57;
	OSCCONbits.IOLOCK=1;

}


void setTRISTATE()
{
	 //Set to ALL inputs until UARTs initialize to fix ARM7 crash issues with initUART_2(), initUART_3(), and initUART_4()
    //causing laser firmware to lockup or lockup and reset by WDT

	//UART 1
	TRISDbits.TRISD4=1; //RX
    TRISDbits.TRISD5=0; //TX
    //UART 2
    TRISDbits.TRISD2=1; //RX
    TRISDbits.TRISD3=0; //TX
    //UART 3
	TRISFbits.TRISF4=0; //TX
	TRISFbits.TRISF5=1; //RX
	//UART 4
	TRISBbits.TRISB14=0; //TX
    TRISBbits.TRISB15=1; //RX

	TRISDbits.TRISD8=1; //INT1 Input

	TRISBbits.TRISB13 = 0;//Test Point "WP1"
	TRISDbits.TRISD11 = 0;//RS-232 Transciever Enable
}

