#define MAX_CMD_SIZE	 64 //10 +2 for prefix
#define MAX_CMD_RSP_SIZE 80
#define CR_KEY	0x0D	// Carriage return
#define NL_KEY	0x0A	// New Line
#define BS_KEY	0x08	// Backspace

extern unsigned char portToDevice;
extern unsigned char portToHost;
extern char isManufModeActive;

extern unsigned char isSystemReady();

typedef struct
{
	char cmd[MAX_CMD_SIZE];
	int maxArgs;
	int prefixReqd; //1 or True if laser specific cmd
	void (*cmdHandler)(void);
} PROTOCOL_CMDS;

void initShadowRegs(void);
void composePrompt(void);
void invalidCommand(void);
void detectLasers(void);
void generalFrontHandler(unsigned char);

void cHandler(void);
void delayHandler(void);
void echoHandler(void);
void epcHandler(void);
void leHandler(void);
void lpHandler(void);
void promptHandler(void);
void tecHandler(void);
void vobtsHandler(void);
void bypassHandler(void);
void pulHandler(void);
void ppHandler(void);
void calTypeHandler(void);

void vortHandler(void);
void burnHandler(void);
void dsysCfgHandler(void);
void calMaxPwrLsrHandler(void);
void calNomLsrPwrHandler(void);
void calNomWaveLenHandler(void);
void calPartNumHandler(void);
void calSerNumHandler(void);
void calBeamShapeHandler(void);
void calStradusMfrModeHandler(void);
void q_calTypeHandler(void);


void q_bptHandler(void);
void q_cHandler(void);
void q_ccHandler(void);
void q_ctHandler(void);
void q_delayHandler(void);
void q_epcHandler(void);
void q_fcHandler(void);
void q_fdHandler(void);
void q_fpHandler(void);
void q_fvHandler(void);
void q_spvHandler(void);
void q_sfvHandler(void);
void q_hHandler(void);
void q_ilHandler(void);
void q_lcHandler(void);
void q_leHandler(void);
void q_lhHandler(void);
void q_liHandler(void);
void q_lpHandler(void);
void q_lpsHandler(void);
void q_lwHandler(void);
void q_maxpHandler(void);
void q_obtHandler(void);
void q_obtsHandler(void);
void q_rpHandler(void);
void q_tecHandler(void);
void q_pulHandler(void);
void q_ppHandler(void);
void q_op1Handler(void);
void q_op2Handler(void);
void q_op3Handler(void);
void q_op4Handler(void);
void q_gui1Handler(void);
void q_typeHandler(void);

