#include "p24FJ256GB106.h"
#include "spi.h"
//spi.c
/*

  union {
    struct {
      unsigned PPRE0:1;
      unsigned PPRE1:1;
      unsigned SPRE0:1;
      unsigned SPRE1:1;
      unsigned SPRE2:1;
      unsigned MSTEN:1;
      unsigned CKP:1;
      unsigned SSEN:1;
      unsigned CKE:1;
      unsigned SMP:1;
      unsigned MODE16:1;
      unsigned DISSDO:1;
      unsigned DISSCK:1;
    };
    struct {
      unsigned PPRE:2;
      unsigned SPRE:3;
    };
  };
} SPI1CON1BITS;


typedef struct tagSPI1CON2BITS {
  unsigned SPIBEN:1;
  unsigned SPIFE:1;
  unsigned :11;
  unsigned SPIFPOL:1;
  unsigned SPIFSD:1;
  unsigned FRMEN:1;
} SPI1CON2BITS;
*/

void initSPI(void)
{
	//SPI Master
	SPI1CON1BITS.DISSCK=0; //0=SDI pin controlled by SPI module
	SPI1CON1BITS.DISSDO=0; //0=SDO pin controlled by SPI module 
	SPI1CON1BITS.MODE16=0; //8 bit mode
	SPI1CON1BITS.SMP=0; //SPI Data Input Sample Phase Bit
	SPI1CON1BITS.CKE=0; //SPI Clock Edge Select Bit
	SPI1CON1BITS.SSEN=0; //Slave Select Enable
	SPI1CON1BITS.CKP=0; //Clock Polarity Select Bit
	SPI1CON1BITS.MSTEN=1; //0=Slave Mode, 1=Master Mode
	SPI1CON1BITS.SPRE=0b000; //2ndary Prescaler (Master Only)
	SPI1CON1BITS.PPRE=0b000; //Primary Prescaler (Master Only)
	
	IPC2bits.SPI1IP=5; //Interrupt Priority	
	IEC0bits.SPI1IE=0; //Disable SPI Interrupts
	
	SPI1STATbits.SPISIDL=0; //Keep SPI working when IDLE
	SPI1STATbits.SPIEN=1; //Enable the SPI module
	
}	

void putCharSPI(unsigned char* myChar)
{
	if(*char)
	{
		SPI1BUF=*myChar;	
	}	
}	

void __attribute__((interrupt, no_auto_psv)) _SPI1Interrupt( void )
{
	IFS0bits.SPI1IF=0; //SPI Interrupt Flag
}	



