#include "timers.h"
#include "p24FJ256GB106.h"

unsigned long int msCount=0; //Timer 1
unsigned long int msT2Count=0;
unsigned long int myDelayTicks=0;



//Timer 1********************************************************
void __attribute__((interrupt, no_auto_psv)) _T1Interrupt( void )
{	
	msCount++;
//	LATA=PORTA^0b00100000;
	TMR1=0x0000;
	IFS0bits.T1IF=0;
}	

void initTimer1(unsigned int periodInMs)
{
   unsigned int counts=0;
   T1CONbits.TON=0;  
   counts=63*periodInMs; //62500cnts/sec OR 62.5cnts/ms
   T1CONbits.TCKPS0=1; //1:(1,8,64,256)
   T1CONbits.TCKPS1=1;
   T1CONbits.TCS=0;
   T1CONbits.TGATE=0;
   T1CONbits.TSYNC=0;
   T1CONbits.TSIDL=0;  
   IPC0bits.T1IP=3; //Priority        
   PR1=counts;
   TMR1=0x0000;	
   msCount=0;  	
}

void startTimer1()
{
   msCount=0;
   T1CONbits.TON=1;
   IFS0bits.T1IF=0; //Clear T1 Int Flag
   IEC0bits.T1IE=1; //Enable T1 Int	
}

void stopTimer1()
{
   IFS0bits.T1IF=0; //Clear T1 Int Flag
   IEC0bits.T1IE=0; //Disable T1 Int	
   T1CONbits.TON=0;	
}

unsigned long int getTimer1Ticks()
{
	return msCount;
}

//Timer 2***********************************************************//
void __attribute__((interrupt, no_auto_psv)) _T2Interrupt( void )
{	
	msT2Count++;
	TMR2=0x0000;
	IFS0bits.T2IF=0;
}

void initTimer2(unsigned int periodInMs)
{
	unsigned int counts=0;

	msT2Count=0;
	T2CONbits.TON=0;
	counts=63*periodInMs;
	T2CONbits.TCKPS0=1; //1:(1,8,64,256)
   	T2CONbits.TCKPS1=1;
   	T2CONbits.T32=0;
   	T2CONbits.TCS=0;
   	T2CONbits.TGATE=0;
   	T2CONbits.TSIDL=0;
   	IPC1bits.T2IP=3; //Priority        
   	PR2=counts;
   	TMR2=0x0000;	
  	msT2Count=0; 	
}

void startTimer2()
{
	msT2Count=0;
   	T2CONbits.TON=1;
   	IFS0bits.T2IF=0; //Clear T2 Int Flag
   	IEC0bits.T2IE=1; //Enable T2 Int
	
}

void stopTimer2()
{
	IFS0bits.T2IF=0; //Clear T2 Int Flag
   	IEC0bits.T2IE=0; //Disable T2 Int	
   	T2CONbits.TON=0;		
}

unsigned long int getTimer2Ticks()
{
	return msT2Count;	
}	

void delayMs(short int periodMs)
{
	initTimer2(1);						
	startTimer2();
		
	while(1) //Block
	{
		if((myDelayTicks = getTimer2Ticks()) > periodMs)
		{
		 	break;
		}	
	}	
	stopTimer2();
}

void delayUs(short int periodUs)
{
	//Calibrated with scope, each NOP is 1us +/-20% 
	//with no interrupts enabled
	Nop();
}

//*******************************************************************//	










	
//EOF

