#include "uart.h"
#include "system.h"
#include "type.h"
#include "config.h"
#include <stdio.h>
#include <string.h>
#include "USB/usbvendreq.h"
#include "timers.h"
#include "extUART.h"
#include "p24FJ256GB106.h"



//RS-232 TX/RX Buffers
unsigned char mySerialU1In[MAX_SERIAL_BUF_SIZE];
unsigned char mySerialU2In[MAX_SERIAL_BUF_SIZE];
unsigned char mySerialU3In[MAX_SERIAL_BUF_SIZE];
unsigned char mySerialU4In[MAX_SERIAL_BUF_SIZE];
unsigned char mySerialUExtIn[MAX_SERIAL_BUF_SIZE];

unsigned char mySerialU1Pos=0;
unsigned char mySerialU2Pos=0;
unsigned char mySerialU3Pos=0;
unsigned char mySerialU4Pos=0;
unsigned char mySerialUExtPos=0;

char outgoing[256];

//EXTERNAL UART RS-232 Tx/Rx Buffers*******************************************
char UExtRx_Buffer[RX_BUFFER_SIZE+1]; // character array (buffer)
unsigned char UExtRX_Wr_Index = 0; //index of next char to be put into the buffer
unsigned char UExtRX_Rd_Index = 0; //index of next char to be fetched from the buffer
unsigned char UExtRX_Counter = 0;  //a total count of characters in the buffer
int  UExtRX_Buffer_Overflow = 0;   // This flag is set on UART Receiver
      					// buffer overflow
char UExtTX_Buffer [TX_BUFFER_SIZE+1]; // character array (buffer)
unsigned char UExtTX_Rd_Index = 0; //index of next char to be put into the buffer
unsigned char UExtTX_Wr_Index = 0; //index of next char to be fetched from the buffer
unsigned char UExtTX_Counter = 0; //a total count of characters in the buffer
int UExtrestart = 0;  // this flag is used to start the transmit
			 // interrupts, when the buffer gets some characters in it		 

//UART 1 (LASER A) RS-232 Tx/Rx Buffers*******************************************
char U1Rx_Buffer[RX_BUFFER_SIZE+1]; // character array (buffer)
unsigned char U1RX_Wr_Index = 0; //index of next char to be put into the buffer
unsigned char U1RX_Rd_Index = 0; //index of next char to be fetched from the buffer
unsigned char U1RX_Counter = 0;  //a total count of characters in the buffer
int  U1RX_Buffer_Overflow = 0;   // This flag is set on UART Receiver
      					// buffer overflow
char U1TX_Buffer [TX_BUFFER_SIZE+1]; // character array (buffer)
unsigned char U1TX_Rd_Index = 0; //index of next char to be put into the buffer
unsigned char U1TX_Wr_Index = 0; //index of next char to be fetched from the buffer
unsigned char U1TX_Counter = 0; //a total count of characters in the buffer
int U1restart = 0;  // this flag is used to start the transmit
			 // interrupts, when the buffer gets some characters in it
			 
//UART 2 (LASER B) RS-232 Tx/Rx Buffers*******************************************
char U2Rx_Buffer[RX_BUFFER_SIZE+1]; // character array (buffer)
unsigned char U2RX_Wr_Index = 0; //index of next char to be put into the buffer
unsigned char U2RX_Rd_Index = 0; //index of next char to be fetched from the buffer
unsigned char U2RX_Counter = 0;  //a total count of characters in the buffer
int  U2RX_Buffer_Overflow = 0;   // This flag is set on UART Receiver
      					// buffer overflow
char U2TX_Buffer [TX_BUFFER_SIZE+1]; // character array (buffer)
unsigned char U2TX_Rd_Index = 0; //index of next char to be put into the buffer
unsigned char U2TX_Wr_Index = 0; //index of next char to be fetched from the buffer
unsigned char U2TX_Counter = 0; //a total count of characters in the buffer
int U2restart = 0;  // this flag is used to start the transmit
			 // interrupts, when the buffer gets some characters in it
//*********************************************************************************
//UART 3 (LASER C) RS-232 Tx/Rx Buffers*******************************************
char U3Rx_Buffer[RX_BUFFER_SIZE+1]; // character array (buffer)
unsigned char U3RX_Wr_Index = 0; //index of next char to be put into the buffer
unsigned char U3RX_Rd_Index = 0; //index of next char to be fetched from the buffer
unsigned char U3RX_Counter = 0;  //a total count of characters in the buffer
int  U3RX_Buffer_Overflow = 0;   // This flag is set on UART Receiver
      					// buffer overflow
char U3TX_Buffer [TX_BUFFER_SIZE+1]; // character array (buffer)
unsigned char U3TX_Rd_Index = 0; //index of next char to be put into the buffer
unsigned char U3TX_Wr_Index = 0; //index of next char to be fetched from the buffer
unsigned char U3TX_Counter = 0; //a total count of characters in the buffer
int U3restart = 0;  // this flag is used to start the transmit
			 // interrupts, when the buffer gets some characters in it
//*********************************************************************************
//UART 4 (LASER D) RS-232 Tx/Rx Buffers*******************************************
char U4Rx_Buffer[RX_BUFFER_SIZE+1]; // character array (buffer)
unsigned char U4RX_Wr_Index = 0; //index of next char to be put into the buffer
unsigned char U4RX_Rd_Index = 0; //index of next char to be fetched from the buffer
unsigned char U4RX_Counter = 0;  //a total count of characters in the buffer
int  U4RX_Buffer_Overflow = 0;   // This flag is set on UART Receiver
      					// buffer overflow
char U4TX_Buffer [TX_BUFFER_SIZE+1]; // character array (buffer)
unsigned char U4TX_Rd_Index = 0; //index of next char to be put into the buffer
unsigned char U4TX_Wr_Index = 0; //index of next char to be fetched from the buffer
unsigned char U4TX_Counter = 0; //a total count of characters in the buffer
int U4restart = 0;  // this flag is used to start the transmit
			 // interrupts, when the buffer gets some characters in it
//*********************************************************************************
int j=0;
			 
extern VOLATILE_REGISTERS shadowRegs;


void initLaserUARTs()
{
	//Based on laserType field in EEPROM setup communication at correct baud-rate and
	//proceed to comm test

	//Laser A
	if(calShadowRegs.laserTypeA==LSR_STRADUS)
	{
		initUART1(19200);    	   			
	}
	else
		if(calShadowRegs.laserTypeA==LSR_OXXIUS)
		{
			initUART1(38400);
		}
	//Laser B
	if(calShadowRegs.laserTypeB==LSR_STRADUS)
	{
		initUART2(19200);
	}
	else
		if(calShadowRegs.laserTypeB==LSR_OXXIUS)
		{
			initUART2(38400);
		}
	//Laser C
	if(calShadowRegs.laserTypeC==LSR_STRADUS)
	{
		initUART3(19200);
	}
	else
		if(calShadowRegs.laserTypeC==LSR_OXXIUS)
		{
			initUART3(38400);
		}
	//Laser D
	if(calShadowRegs.laserTypeD==LSR_STRADUS)
	{
		initUART4(19200);
	}
	else
		if(calShadowRegs.laserTypeD==LSR_OXXIUS)
		{
			initUART4(38400);
		}	
}	

	

void initUART1(unsigned short baudRate) 
{
	U1MODEbits.UARTEN = 0;	// Bit15 TX, RX DISABLED, ENABLE at end of func
	U1MODEbits.USIDL = 0;	// Bit13 Continue in Idle
	U1MODEbits.IREN = 0;	// Bit12 No IR translation
	U1MODEbits.RTSMD = 1;	// Bit11 Simplex Mode
	U1MODEbits.UEN = 0;		// Bits8,9 TX,RX enabled, CTS,RTS not
	U1MODEbits.WAKE = 0;	// Bit7 No Wake up (since we don't sleep here)
	U1MODEbits.LPBACK = 0;	// Bit6 No Loop Back
	U1MODEbits.ABAUD = 0;	// Bit5 No Autobaud (would require sending '55')
	//U1MODEbits.URXINV = 0;	// Bit4 IdleState = 1  (for dsPIC)
	U1MODEbits.BRGH = 0;	// Bit3 16 clocks per bit period
	U1MODEbits.PDSEL = 0;	// Bits1,2 8bit, No Parity
	U1MODEbits.STSEL = 0;	// Bit0 One Stop Bit
	
	// Load a value into Baud Rate Generator.  Example is for 19200.
	// See section 19.3.1 of datasheet.
	//  U1BRG = (Fcy/(16*BaudRate))-1
	//  U1BRG = ((32MHz/2)/(16*19200))-1=51
	//  U1BRG = 51
	U1BRG=((unsigned short)(1000000/baudRate))-1;

	// Load all values in for U1STA SFR
	U1STAbits.UTXISEL1 = 0;	//Bit15 Int when Char is transferred
	U1STAbits.UTXINV = 0;	//Bit14 N/A, IRDA config
	U1STAbits.UTXISEL0 = 0;	//Bit13 Other half of Bit15
	U1STAbits.UTXBRK = 0;	//Bit11 Disabled
	U1STAbits.UTXEN = 0;	//Bit10 TX pins controlled by periph
	U1STAbits.UTXBF = 0;	//Bit9 *Read Only Bit*
	U1STAbits.TRMT = 0;	//Bit8 *Read Only bit*
	U1STAbits.URXISEL = 0;	//Bits6,7 Int. on character recieved
	U1STAbits.ADDEN = 0;	//Bit5 Address Detect Disabled
	U1STAbits.RIDLE = 0;	//Bit4 *Read Only Bit*
	U1STAbits.PERR = 0;		//Bit3 *Read Only Bit*
	U1STAbits.FERR = 0;		//Bit2 *Read Only Bit*
	U1STAbits.OERR = 0;		//Bit1 *Read Only Bit*
	U1STAbits.URXDA = 0;	//Bit0 *Read Only Bit*

	IPC7 = 0x4400;	// Mid Range Interrupt Priority level, no urgent reason

	IFS0bits.U1TXIF = 0;	// Clear the Transmit Interrupt Flag
	
	//IEC0bits.U1TXIE = 1;	// Enable Transmit Interrupts
	//IEC0bits.U1TXIE = 0;	// Disable Transmit Interrupts
	
	IFS0bits.U1RXIF = 0;	// Clear the Recieve Interrupt Flag
	IEC0bits.U1RXIE = 1;	// Enable Recieve Interrupts
	U1MODEbits.UARTEN = 1;	// And turn the peripheral on	
	U1STAbits.UTXEN = 1;	//MUST FOLLOW UxMODEbits.UARTEN=1
		
}

void initUART2(unsigned short baudRate)
{
	U2MODEbits.UARTEN = 0;	// Bit15 TX, RX DISABLED, ENABLE at end of func
	U2MODEbits.USIDL = 0;	// Bit13 Continue in Idle
	U2MODEbits.IREN = 0;	// Bit12 No IR translation
	U2MODEbits.RTSMD = 1;	// Bit11 Simplex Mode
	U2MODEbits.UEN = 0;		// Bits8,9 TX,RX enabled, CTS,RTS not
	U2MODEbits.WAKE = 0;	// Bit7 No Wake up (since we don't sleep here)
	U2MODEbits.LPBACK = 0;	// Bit6 No Loop Back
	U2MODEbits.ABAUD = 0;	// Bit5 No Autobaud (would require sending '55')
	//U2MODEbits.URXINV = 0;	// Bit4 IdleState = 1  (for dsPIC)
	U2MODEbits.BRGH = 0;	// Bit3 16 clocks per bit period
	U2MODEbits.PDSEL = 0;	// Bits1,2 8bit, No Parity
	U2MODEbits.STSEL = 0;	// Bit0 One Stop Bit
	
	// Load a value into Baud Rate Generator.  Example is for 19200.
	// See section 19.3.1 of datasheet.
	//  U1BRG = (Fcy/(16*BaudRate))-1
	//  U1BRG = ((32MHz/2)/(16*19200))-1=51
	//  U1BRG = 51
	U2BRG=((unsigned short)(1000000/baudRate))-1; //25

	// Load all values in for U1STA SFR
	U2STAbits.UTXISEL1 = 0;	//Bit15 Int when Char is transferred
	U2STAbits.UTXINV = 0;	//Bit14 N/A, IRDA config
	U2STAbits.UTXISEL0 = 0;	//Bit13 Other half of Bit15
	U2STAbits.UTXBRK = 0;	//Bit11 Disabled
	U2STAbits.UTXEN = 0;	//Bit10 TX pins controlled by periph
	U2STAbits.UTXBF = 0;	//Bit9 *Read Only Bit*
	U2STAbits.TRMT = 0;	//Bit8 *Read Only bit*
	U2STAbits.URXISEL = 0;	//Bits6,7 Int. on character recieved
	U2STAbits.ADDEN = 0;	//Bit5 Address Detect Disabled
	U2STAbits.RIDLE = 0;	//Bit4 *Read Only Bit*
	U2STAbits.PERR = 0;		//Bit3 *Read Only Bit*
	U2STAbits.FERR = 0;		//Bit2 *Read Only Bit*
	U2STAbits.OERR = 0;		//Bit1 *Read Only Bit*
	U2STAbits.URXDA = 0;	//Bit0 *Read Only Bit*

	IPC7 = 0x4400;	// Mid Range Interrupt Priority level, no urgent reason	

	IFS1bits.U2TXIF = 0;	// Clear the Transmit Interrupt Flag
	//IEC1bits.U2TXIE = 1;	// Enable Transmit Interrupts
	IFS1bits.U2RXIF = 0;	// Clear the Recieve Interrupt Flag
	IEC1bits.U2RXIE = 1;	// Enable Recieve Interrupts

	U2MODEbits.UARTEN = 1;	// And turn the peripheral on

	U2STAbits.UTXEN = 1;		
}

void initUART3(unsigned short baudRate)
{
	U3MODEbits.UARTEN = 0;	// Bit15 TX, RX DISABLED, ENABLE at end of func
	U3MODEbits.USIDL = 0;	// Bit13 Continue in Idle
	U3MODEbits.IREN = 0;	// Bit12 No IR translation
	U3MODEbits.RTSMD = 1;	// Bit11 Simplex Mode
	U3MODEbits.UEN = 0;		// Bits8,9 TX,RX enabled, CTS,RTS not
	U3MODEbits.WAKE = 0;	// Bit7 No Wake up (since we don't sleep here)
	U3MODEbits.LPBACK = 0;	// Bit6 No Loop Back
	U3MODEbits.ABAUD = 0;	// Bit5 No Autobaud (would require sending '55')
	//U3MODEbits.URXINV = 0;	// Bit4 IdleState = 1  (for dsPIC)
	U3MODEbits.BRGH = 0;	// Bit3 16 clocks per bit period
	U3MODEbits.PDSEL = 0;	// Bits1,2 8bit, No Parity
	U3MODEbits.STSEL = 0;	// Bit0 One Stop Bit
	
	// Load a value into Baud Rate Generator.  Example is for 19200.
	// See section 19.3.1 of datasheet.
	//  U1BRG = (Fcy/(16*BaudRate))-1
	//  U1BRG = ((32MHz/2)/(16*19200))-1=51
	//  U1BRG = 51
	U3BRG=((unsigned short)(1000000/baudRate))-1;

	// Load all values in for U1STA SFR
	U3STAbits.UTXISEL1 = 0;	//Bit15 Int when Char is transferred
	U3STAbits.UTXINV = 0;	//Bit14 N/A, IRDA config
	U3STAbits.UTXISEL0 = 0;	//Bit13 Other half of Bit15
	U3STAbits.UTXBRK = 0;	//Bit11 Disabled
	U3STAbits.UTXEN = 0;	//Bit10 TX pins controlled by periph
	U3STAbits.UTXBF = 0;	//Bit9 *Read Only Bit*
	U3STAbits.TRMT = 0;	//Bit8 *Read Only bit*
	U3STAbits.URXISEL = 0;	//Bits6,7 Int. on character recieved
	U3STAbits.ADDEN = 0;	//Bit5 Address Detect Disabled
	U3STAbits.RIDLE = 0;	//Bit4 *Read Only Bit*
	U3STAbits.PERR = 0;		//Bit3 *Read Only Bit*
	U3STAbits.FERR = 0;		//Bit2 *Read Only Bit*
	U3STAbits.OERR = 0;		//Bit1 *Read Only Bit*
	U3STAbits.URXDA = 0;	//Bit0 *Read Only Bit*

	IPC7 = 0x4400;	// Mid Range Interrupt Priority level, no urgent reason

	IFS5bits.U3TXIF = 0;	// Clear the Transmit Interrupt Flag
	//IEC5bits.U3TXIE = 1;	// Enable Transmit Interrupts
	IFS5bits.U3RXIF = 0;	// Clear the Recieve Interrupt Flag
	IEC5bits.U3RXIE = 1;	// Enable Recieve Interrupts

	U3MODEbits.UARTEN = 1;	// And turn the peripheral on

	U3STAbits.UTXEN = 1;		
}

void initUART4(unsigned short baudRate)
{
	U4MODEbits.UARTEN = 0;	// Bit15 TX, RX DISABLED, ENABLE at end of func
	U4MODEbits.USIDL = 0;	// Bit13 Continue in Idle
	U4MODEbits.IREN = 0;	// Bit12 No IR translation
	U4MODEbits.RTSMD = 1;	// Bit11 Simplex Mode
	U4MODEbits.UEN = 0;		// Bits8,9 TX,RX enabled, CTS,RTS not
	U4MODEbits.WAKE = 0;	// Bit7 No Wake up (since we don't sleep here)
	U4MODEbits.LPBACK = 0;	// Bit6 No Loop Back
	U4MODEbits.ABAUD = 0;	// Bit5 No Autobaud (would require sending '55')
	//U4MODEbits.URXINV = 0;	// Bit4 IdleState = 1  (for dsPIC)
	U4MODEbits.BRGH = 0;	// Bit3 16 clocks per bit period
	U4MODEbits.PDSEL = 0;	// Bits1,2 8bit, No Parity
	U4MODEbits.STSEL = 0;	// Bit0 One Stop Bit
	
	// Load a value into Baud Rate Generator.  Example is for 19200.
	// See section 19.3.1 of datasheet.
	//  U1BRG = (Fcy/(16*BaudRate))-1
	//  U1BRG = ((32MHz/2)/(16*19200))-1=51
	//  U1BRG = 51
	U4BRG=((unsigned short)(1000000/baudRate))-1;

	// Load all values in for U1STA SFR
	U4STAbits.UTXISEL1 = 0;	//Bit15 Int when Char is transferred
	U4STAbits.UTXINV = 0;	//Bit14 N/A, IRDA config
	U4STAbits.UTXISEL0 = 0;	//Bit13 Other half of Bit15
	U4STAbits.UTXBRK = 0;	//Bit11 Disabled
	U4STAbits.UTXEN = 0;	//Bit10 TX pins controlled by periph
	U4STAbits.UTXBF = 0;	//Bit9 *Read Only Bit*
	U4STAbits.TRMT = 0;	//Bit8 *Read Only bit*
	U4STAbits.URXISEL = 0;	//Bits6,7 Int. on character recieved
	U4STAbits.ADDEN = 0;	//Bit5 Address Detect Disabled
	U4STAbits.RIDLE = 0;	//Bit4 *Read Only Bit*
	U4STAbits.PERR = 0;		//Bit3 *Read Only Bit*
	U4STAbits.FERR = 0;		//Bit2 *Read Only Bit*
	U4STAbits.OERR = 0;		//Bit1 *Read Only Bit*
	U4STAbits.URXDA = 0;	//Bit0 *Read Only Bit*

	IPC7 = 0x4400;	// Mid Range Interrupt Priority level, no urgent reason

	IFS5bits.U4TXIF = 0;	// Clear the Transmit Interrupt Flag
	//IEC5bits.U4TXIE = 1;	// Enable Transmit Interrupts
	IFS5bits.U4RXIF = 0;	// Clear the Recieve Interrupt Flag
	IEC5bits.U4RXIE = 1;	// Enable Recieve Interrupts

	U4MODEbits.UARTEN = 1;	// And turn the peripheral on

	U4STAbits.UTXEN = 1;		
}	

unsigned char getExtRXCount()
{
	unsigned char RXcount=0;

	if((uchar *)&UExtRx_Buffer[UExtRX_Wr_Index] > (uchar *)&UExtRx_Buffer[UExtRX_Rd_Index])
	{
		RXcount=&UExtRx_Buffer[UExtRX_Wr_Index] - &UExtRx_Buffer[UExtRX_Rd_Index];
	}
	else
		if((uchar *)&UExtRx_Buffer[UExtRX_Wr_Index] == (uchar *)&UExtRx_Buffer[UExtRX_Rd_Index])
		{
			RXcount=0;
		}
		else
		{
			RXcount=(uchar *)&UExtRx_Buffer[RX_BUFFER_SIZE+1] - (uchar *)&UExtRx_Buffer[UExtRX_Rd_Index];
			RXcount+= (uchar *)&UExtRx_Buffer[UExtRX_Wr_Index] - (uchar *)&UExtRx_Buffer[0];
		}

	return RXcount;
}

unsigned char getU1RXCount()
{
	unsigned char RXcount=0;

	if((uchar *)&U1Rx_Buffer[U1RX_Wr_Index] > (uchar *)&U1Rx_Buffer[U1RX_Rd_Index])
	{
		RXcount=&U1Rx_Buffer[U1RX_Wr_Index] - &U1Rx_Buffer[U1RX_Rd_Index];
	}
	else
		if((uchar *)&U1Rx_Buffer[U1RX_Wr_Index] == (uchar *)&U1Rx_Buffer[U1RX_Rd_Index])
		{
			RXcount=0;
		}
		else
		{
			RXcount=(uchar *)&U1Rx_Buffer[RX_BUFFER_SIZE+1] - (uchar *)&U1Rx_Buffer[U1RX_Rd_Index];
			RXcount+= (uchar *)&U1Rx_Buffer[U1RX_Wr_Index] - (uchar *)&U1Rx_Buffer[0];
		}

	return RXcount;
}

unsigned char getU2RXCount()
{
	unsigned char RXcount=0;

	if((uchar *)&U2Rx_Buffer[U2RX_Wr_Index] > (uchar *)&U2Rx_Buffer[U2RX_Rd_Index])
	{
		RXcount=&U2Rx_Buffer[U2RX_Wr_Index] - &U2Rx_Buffer[U2RX_Rd_Index];
	}
	else
		if((uchar *)&U2Rx_Buffer[U2RX_Wr_Index] == (uchar *)&U2Rx_Buffer[U2RX_Rd_Index])
		{
			RXcount=0;
		}
		else
		{
			RXcount=(uchar *)&U2Rx_Buffer[RX_BUFFER_SIZE+1] - (uchar *)&U2Rx_Buffer[U2RX_Rd_Index];
			RXcount+= (uchar *)&U2Rx_Buffer[U2RX_Wr_Index] - (uchar *)&U2Rx_Buffer[0];
		}

	return RXcount;
}

unsigned char getU3RXCount()
{
	unsigned char RXcount=0;

	if((uchar *)&U3Rx_Buffer[U3RX_Wr_Index] > (uchar *)&U3Rx_Buffer[U3RX_Rd_Index])
	{
		RXcount=&U3Rx_Buffer[U3RX_Wr_Index] - &U3Rx_Buffer[U3RX_Rd_Index];
	}
	else
		if((uchar *)&U3Rx_Buffer[U3RX_Wr_Index] == (uchar *)&U3Rx_Buffer[U3RX_Rd_Index])
		{
			RXcount=0;
		}
		else
		{
			RXcount=(uchar *)&U3Rx_Buffer[RX_BUFFER_SIZE+1] - (uchar *)&U3Rx_Buffer[U3RX_Rd_Index];
			RXcount+= (uchar *)&U3Rx_Buffer[U3RX_Wr_Index] - (uchar *)&U3Rx_Buffer[0];
		}

	return RXcount;
}

unsigned char getU4RXCount()
{
	unsigned char RXcount=0;

	if((uchar *)&U4Rx_Buffer[U4RX_Wr_Index] > (uchar *)&U4Rx_Buffer[U4RX_Rd_Index])
	{
		RXcount=&U4Rx_Buffer[U4RX_Wr_Index] - &U4Rx_Buffer[U4RX_Rd_Index];
	}
	else
		if((uchar *)&U4Rx_Buffer[U4RX_Wr_Index] == (uchar *)&U4Rx_Buffer[U4RX_Rd_Index])
		{
			RXcount=0;
		}
		else
		{
			RXcount=(uchar *)&U4Rx_Buffer[RX_BUFFER_SIZE+1] - (uchar *)&U4Rx_Buffer[U4RX_Rd_Index];
			RXcount+= (uchar *)&U4Rx_Buffer[U4RX_Wr_Index] - (uchar *)&U4Rx_Buffer[0];
		}

	return RXcount;
}

			
//Interrupt Handlers********************************************
void __attribute__ ((interrupt, no_auto_psv)) _U1RXInterrupt(void) 
{	
	IFS0bits.U1RXIF = 0; //Clear RX Int Flag

	while(U1STAbits.URXDA) //One or more bytes in UART buffer 
	{
		if(mySerialU1Pos > MAX_SERIAL_BUF_SIZE)
			mySerialU1Pos = 0;
		mySerialU1In[mySerialU1Pos++] = U1RXREG;
	}
#if 0
		U1Rx_Buffer[U1RX_Wr_Index]=U1RXREG; //get char from Rx Register
		if(++U1RX_Wr_Index > RX_BUFFER_SIZE) // wrap the pointer 
    	{
        	U1RX_Wr_Index = 0;
    	}    

    	if(++U1RX_Counter > RX_BUFFER_SIZE) // keep a character count 
    	{                                 // overflow check.. 
    		U1RX_Counter = RX_BUFFER_SIZE; // if too many chars came 
    		U1RX_Buffer_Overflow = 1;	// in before they could be used 
		}					// that could cause an error!! 	
#endif		
}

void __attribute__ ((interrupt, no_auto_psv)) _U1TXInterrupt(void) 
{			
	IFS0bits.U1TXIF = 0; //Clear TX Interrupt Flag
	
	if(U1TX_Counter != 0)
    {
	    while(U1STAbits.UTXBF==1); /* wait if the buffer is full */
	    U1TXREG = U1TX_Buffer[U1TX_Rd_Index]; //Place char into Tx Register
	    //putchar(U1TX_Buffer[U1TX_Rd_Index]);
	   	if(++U1TX_Rd_Index > TX_BUFFER_SIZE)
	   	{
		    U1TX_Rd_Index = 0;
	    } 
		U1TX_Counter--;	// keep track of the counter 
        //if (U1TX_Counter == 0)
        //{
            //IEC0bits.U1TXIE=0; //Disable TX Interrupts
        //}             
	}	        									
}

void __attribute__ ((interrupt, no_auto_psv)) _U2RXInterrupt(void) 
{	
	IFS1bits.U2RXIF = 0; //Clear RX Int Flag
	
	while(U2STAbits.URXDA) //One or more bytes in UART buffer 
	{
		if(mySerialU2Pos > MAX_SERIAL_BUF_SIZE)
			mySerialU2Pos = 0;
		mySerialU2In[mySerialU2Pos++] = U2RXREG;
	}
#if 0
		U2Rx_Buffer[U2RX_Wr_Index]=U2RXREG; //get char from Rx Register

    	if(++U2RX_Wr_Index > RX_BUFFER_SIZE) // wrap the pointer 
    	{
        	U2RX_Wr_Index = 0;
    	}    

    	if(++U2RX_Counter > RX_BUFFER_SIZE) // keep a character count 
    	{                                 // overflow check.. 
    		U2RX_Counter = RX_BUFFER_SIZE; // if too many chars came 
    		U2RX_Buffer_Overflow = 1;	// in before they could be used 
		}				// that could cause an error!! 	
#endif
		
		
					
}

void __attribute__ ((interrupt, no_auto_psv)) _U2TXInterrupt(void) 
{		
	IFS1bits.U2TXIF = 0; //Clear TX Interrupt Flag
	if(U2TX_Counter != 0)
    {
	    while(U2STAbits.UTXBF); /* wait if the buffer is full */
	    U2TXREG = U2TX_Buffer[U2TX_Rd_Index]; //Place char into Tx Register
	   	if(++U2TX_Rd_Index > TX_BUFFER_SIZE)
	   	{
		    U2TX_Rd_Index = 0;
	    } 
		U2TX_Counter--;	// keep track of the counter 
        //if (U2TX_Counter == 0)
        //{
            //IEC1bits.U2TXIE=0; //Disable TX Interrupts
        //}             
	}								
}

void __attribute__ ((interrupt, no_auto_psv)) _U3RXInterrupt(void) 
{	
	IFS5bits.U3RXIF = 0; //Clear RX Int Flag 

	while(U3STAbits.URXDA) //One or more bytes in UART buffer 
	{
		if(mySerialU3Pos > MAX_SERIAL_BUF_SIZE)
			mySerialU3Pos = 0;
		mySerialU3In[mySerialU3Pos++] = U3RXREG;
	}
#if 0

		U3Rx_Buffer[U3RX_Wr_Index]=U3RXREG; //get char from Rx Register

    	if(++U3RX_Wr_Index > RX_BUFFER_SIZE) // wrap the pointer 
    	{
        	U3RX_Wr_Index = 0;
    	}    

    	if(++U3RX_Counter > RX_BUFFER_SIZE) // keep a character count 
    	{                                 // overflow check.. 
    		U3RX_Counter = RX_BUFFER_SIZE; // if too many chars came 
    		U3RX_Buffer_Overflow = 1;	// in before they could be used 
		}					// that could cause an error!!	
#endif	
}

void __attribute__ ((interrupt, no_auto_psv)) _U3TXInterrupt(void) 
{		
	IFS5bits.U3TXIF = 0; //Clear TX Interrupt Flag
	if(U3TX_Counter != 0)
    {
	    while(U3STAbits.UTXBF); /* wait if the buffer is full */
	    U3TXREG = U3TX_Buffer[U3TX_Rd_Index]; //Place char into Tx Register
	   	if(++U3TX_Rd_Index > TX_BUFFER_SIZE)
	   	{
		    U3TX_Rd_Index = 0;
	    } 
		U3TX_Counter--;	// keep track of the counter 
        //if (U3TX_Counter == 0)
        //{
            //IEC1bits.U3TXIE=0; //Disable TX Interrupts
        //}             
	}
								
}

void __attribute__ ((interrupt, no_auto_psv)) _U4RXInterrupt(void) 
{	
	IFS5bits.U4RXIF = 0; //Clear RX Int Flag 

	while(U4STAbits.URXDA) //One or more bytes in UART buffer 
	{
		if(mySerialU4Pos > MAX_SERIAL_BUF_SIZE)
			mySerialU4Pos = 0;
		mySerialU4In[mySerialU4Pos++] = U4RXREG;
	}
#if 0	

		U4Rx_Buffer[U4RX_Wr_Index]=U4RXREG; //get char from Rx Register

    	if(++U4RX_Wr_Index > RX_BUFFER_SIZE) // wrap the pointer 
    	{
        	U4RX_Wr_Index = 0;
    	}    

    	if(++U4RX_Counter > RX_BUFFER_SIZE) // keep a character count 
    	{                                 // overflow check.. 
    		U4RX_Counter = RX_BUFFER_SIZE; // if too many chars came 
    		U4RX_Buffer_Overflow = 1;	// in before they could be used 
		}					// that could cause an error!!
#endif
}

void __attribute__ ((interrupt, no_auto_psv)) _U4TXInterrupt(void) 
{		
	IFS5bits.U4TXIF = 0; //Clear TX Interrupt Flag	
	if(U4TX_Counter != 0)
    {
	    while(U4STAbits.UTXBF); /* wait if the buffer is full */
	    U4TXREG = U4TX_Buffer[U4TX_Rd_Index]; //Place char into Tx Register
	   	if(++U4TX_Rd_Index > TX_BUFFER_SIZE)
	   	{
		    U4TX_Rd_Index = 0;
	    } 
		U4TX_Counter--;	// keep track of the counter 
        //if (U4TX_Counter == 0)
        //{
            //IEC5bits.U4TXIE=0; //Disable TX Interrupts
        //}             
	}	   	
						
}

void putTheChar(unsigned char myPort, char theChar)
{
	sprintf(outgoing,"%c",theChar);	
	switch(myPort)
	{
		case UART_1:
			sendString(UART_1,outgoing);
			break;
		case UART_2:
			sendString(UART_2,outgoing);
			break;
		case UART_3:
			sendString(UART_3,outgoing);
			break;
		case UART_4:
			sendString(UART_4,outgoing);
			break;
		case EXT_UART:
			sendString(EXT_UART,outgoing);
			break;	
	}				
}

unsigned char toUpper(unsigned char inputChar)
{
	if(inputChar>=97&&inputChar<=122)
	{
		return inputChar-32;
	}
	else
	{	
		return inputChar;
	}		
}
void sendString (unsigned char myPort, char* outputString) // Write characters to Serial Port, or USB port
{	
	int i=0;
	volatile short myTicks = 0;
	static unsigned char myCnt=0;
	unsigned char didTimeOutOccur=FALSE;
	switch(myPort)
	{
		case EXT_UART:
			for(i=0;i<strlen(outputString);i++)
			{
				//Transmit a character
				extUARTWrite(THR,(unsigned char*)&outputString[i],1);
			}
			break;
		case UART_1:
			for(i=0;i<strlen(outputString);i++)
			{
				while(U1STAbits.UTXBF == 1);
     	    	U1TXREG = outputString[i];		
			}
			break;
		case UART_2:
			for(i=0;i<strlen(outputString);i++)
			{
				while(U2STAbits.UTXBF == 1);
     	    	U2TXREG = outputString[i];		
			}
			break;
		case UART_3:
			for(i=0;i<strlen(outputString);i++)
			{	
				while(U3STAbits.UTXBF == 1);
     	    	U3TXREG = outputString[i];		
			}
			break;
		case UART_4:
			for(i=0;i<strlen(outputString);i++)
			{
				while(U4STAbits.UTXBF == 1);
     	    	U4TXREG = outputString[i];		
			}
			break;
		case USB_PORT: //Add chars to USB message		
			//Init Timer2 for USB Timer
			initTimer2(20);			
			//Start Timer2 for USB Timeout
			startTimer2();
			
			while(UsbInPending==0x0001)
			{
				if((myTicks = getTimer2Ticks()) > 50) //1sec
				{
					didTimeOutOccur = TRUE;
			 		break;
				}	
			}	
		    stopTimer2();
					
			if(didTimeOutOccur)
			{
				//Clear outgoing string from USB IN Buffer for clean slate upon new USB connection				
				memset(myUsbInTmpBuf, 0, sizeof(myUsbInTmpBuf)); //Clears all myUsbInTmpBuf elements to 0x00	
				UsbInPending=0x0000;		
			}
			else
			{
				//Load a new string for USB IN transfer
				while(*outputString)
				{
					if(myCnt < 64)
						myUsbInTmpBuf[myCnt++] = *outputString++;
				}	
				
				myUsbInTmpBuf[myCnt++] = 0; //Place NULL at end of string
					
				//if(myCnt>0)
				//{
					UsbInPending=0x0001;
									
				//}				
			}	
			myCnt=0; //Reset for next response														
			break;
		default:
			break;		
	}		
}


//***************************************************************
void U1bputc(char c)
{
	U1restart=0;
    while(U1TX_Counter > (TX_BUFFER_SIZE-1));       // WAIT!! Buffer is getting full!! 

    if(U1TX_Counter == 0) // if buffer empty, setup for interrupt 
    {
    	U1restart = 1;
    }	

    U1TX_Buffer[U1TX_Wr_Index++]=c; // jam the char in the buffer.. 

    if(U1TX_Wr_Index > TX_BUFFER_SIZE)  	// wrap the pointer 
    {
        U1TX_Wr_Index = 0;
    }    
    // keep track of buffered chars 
    U1TX_Counter++;

    // do we have to "Prime the pump"? 
    if(U1restart == 1)
    {    
	    IFS0bits.U1TXIF = 0; //Clear Transmit Interrupt Flag
	    IEC0bits.U1TXIE=1; //Enable TX Interrupt	           
    }    
}

// Get a character from the UART Receiver buffer
char U1bgetc(void)
{
	char c;

	while(U1RX_Counter == 0)		// wait for a character... 
		;

	c = U1Rx_Buffer[U1RX_Rd_Index];	// get one from the buffer...

    if(++U1RX_Rd_Index > RX_BUFFER_SIZE) // wrap the pointer 
    {
        U1RX_Rd_Index = 0;
    }    

	if(U1RX_Counter)
	{
		U1RX_Counter--;        // keep a count (buffer size) 
	}	

	return c;
}
//***************************************************************
void U2bputc(char c)
{
	U2restart=0;
    while(U2TX_Counter > (TX_BUFFER_SIZE-1));       // WAIT!! Buffer is getting full!! 

    if(U2TX_Counter == 0) // if buffer empty, setup for interrupt 
    {
    	U2restart = 1;
    }	

    U2TX_Buffer[U2TX_Wr_Index++]=c; // jam the char in the buffer.. 

    if(U2TX_Wr_Index > TX_BUFFER_SIZE)  	// wrap the pointer 
    {
        U2TX_Wr_Index = 0;
    }    
    // keep track of buffered chars 
    U2TX_Counter++;

    // do we have to "Prime the pump"? 
    if(U2restart == 1)
    {    
	    IFS1bits.U2TXIF = 0; //Clear Transmit Interrupt Flag
	    IEC1bits.U2TXIE=1; //Enable TX Interrupt	           
    }        
}

// Get a character from the UART Receiver buffer
char U2bgetc(void)
{
	char c;

	while(U2RX_Counter == 0)		// wait for a character... 
		;

	c = U2Rx_Buffer[U2RX_Rd_Index];	// get one from the buffer...

    if(++U2RX_Rd_Index > RX_BUFFER_SIZE) // wrap the pointer 
    {
        U2RX_Rd_Index = 0;
    }    

	if(U2RX_Counter)
	{
		U2RX_Counter--;        // keep a count (buffer size) 
	}	

	return c;
}
//***************************************************************
void U3bputc(char c)
{
	U3restart=0;
    while(U3TX_Counter > (TX_BUFFER_SIZE-1));       // WAIT!! Buffer is getting full!! 

    if(U3TX_Counter == 0) // if buffer empty, setup for interrupt 
    {
    	U3restart = 1;
    }	

    U3TX_Buffer[U3TX_Wr_Index++]=c; // jam the char in the buffer.. 

    if(U3TX_Wr_Index > TX_BUFFER_SIZE)  	// wrap the pointer 
    {
        U3TX_Wr_Index = 0;
    }    
    // keep track of buffered chars 
    U3TX_Counter++;

    // do we have to "Prime the pump"? 
    if(U3restart == 1)
    {    
	    IFS5bits.U3TXIF = 0; //Clear Transmit Interrupt Flag
	    IEC5bits.U3TXIE=1; //Enable TX Interrupt	           
    }        
}

// Get a character from the UART Receiver buffer
char U3bgetc(void)
{
	char c;

	while(U3RX_Counter == 0)		// wait for a character... 
		;

	c = U3Rx_Buffer[U3RX_Rd_Index];	// get one from the buffer...

    if(++U3RX_Rd_Index > RX_BUFFER_SIZE) // wrap the pointer 
    {
        U3RX_Rd_Index = 0;
    }    

	if(U3RX_Counter)
	{
		U3RX_Counter--;        // keep a count (buffer size) 
	}	

	return c;
}
//***************************************************************
void U4bputc(char c)
{
	U4restart=0;
    while(U4TX_Counter > (TX_BUFFER_SIZE-1));       // WAIT!! Buffer is getting full!! 

    if(U4TX_Counter == 0) // if buffer empty, setup for interrupt 
    {
    	U4restart = 1;
    }	

    U4TX_Buffer[U4TX_Wr_Index++]=c; // jam the char in the buffer.. 

    if(U4TX_Wr_Index > TX_BUFFER_SIZE)  	// wrap the pointer 
    {
        U4TX_Wr_Index = 0;
    }    
    // keep track of buffered chars 
    U4TX_Counter++;

    // do we have to "Prime the pump"? 
    if(U4restart == 1)
    {    
	    IFS5bits.U4TXIF = 0; //Clear Transmit Interrupt Flag
	    IEC5bits.U4TXIE=1; //Enable TX Interrupt	           
    }        
}

// Get a character from the UART Receiver buffer
char U4bgetc(void)
{
	char c;

	while(U4RX_Counter == 0)		// wait for a character... 
		;

	c = U4Rx_Buffer[U4RX_Rd_Index];	// get one from the buffer...

    if(++U4RX_Rd_Index > RX_BUFFER_SIZE) // wrap the pointer 
    {
        U4RX_Rd_Index = 0;
    }    

	if(U4RX_Counter)
	{
		U4RX_Counter--;        // keep a count (buffer size) 
	}	

	return c;
}

// Get a character from the UART Receiver buffer
char UExtbgetc(void)
{
	char c;

	while(UExtRX_Counter == 0)		// wait for a character... 
		;

	c = UExtRx_Buffer[UExtRX_Rd_Index];	// get one from the buffer...

    if(++UExtRX_Rd_Index > RX_BUFFER_SIZE) // wrap the pointer 
    {
        UExtRX_Rd_Index = 0;
    }    

	if(UExtRX_Counter)
	{
		UExtRX_Counter--;        // keep a count (buffer size) 
	}	

	return c;
}

void UExtbputc(char c)
{
	UExtrestart=0;
    while(UExtTX_Counter > (TX_BUFFER_SIZE-1));       // WAIT!! Buffer is getting full!! 

    if(UExtTX_Counter == 0) // if buffer empty, setup for interrupt 
    {
    	UExtrestart = 1;
    }	

    UExtTX_Buffer[UExtTX_Wr_Index++]=c; // jam the char in the buffer.. 

    if(UExtTX_Wr_Index > TX_BUFFER_SIZE)  	// wrap the pointer 
    {
        UExtTX_Wr_Index = 0;
    }    
    // keep track of buffered chars 
    UExtTX_Counter++;

    // do we have to "Prime the pump"? 
    if(UExtrestart == 1)
    {    
	    //IFS5bits.U4TXIF = 0; //Clear Transmit Interrupt Flag
	    //IEC5bits.U4TXIE=1; //Enable TX Interrupt	           
    }        
}

void extUARTHdlr(unsigned char charIn)
{	
	if(mySerialUExtPos > MAX_SERIAL_BUF_SIZE)
		mySerialUExtPos = 0;
	mySerialUExtIn[mySerialUExtPos++] = charIn;
	
#if 0
	UExtRx_Buffer[UExtRX_Wr_Index]=charIn; //get char from Rx Register
	if(++UExtRX_Wr_Index > RX_BUFFER_SIZE) // wrap the pointer 
    {
        UExtRX_Wr_Index = 0;
    }    

    if(++UExtRX_Counter > RX_BUFFER_SIZE) // keep a character count 
    {                                 // overflow check.. 
    	UExtRX_Counter = RX_BUFFER_SIZE; // if too many chars came 
    	UExtRX_Buffer_Overflow = 1;	// in before they could be used 
	}	// that could cause an error!! 	
#endif
}


//****************************************************************	





