#define RX_BUFFER_SIZE 80
#define TX_BUFFER_SIZE 64
#define MAX_SERIAL_BUF_SIZE	64

#define MAX_TIMEOUT_USB 50
#define MAX_USB_TIMEOUT_IN_TICKS 20

void initUART1(unsigned short baudRate); 
void initUART2(unsigned short baudRate); 
void initUART3(unsigned short baudRate); 
void initUART4(unsigned short baudRate); 	

void initLaserUARTs(void);

//Interrupt Handlers********************************************
void __attribute__ ((interrupt, no_auto_psv)) _U1RXInterrupt(void);

void __attribute__ ((interrupt, no_auto_psv)) _U1TXInterrupt(void);

void __attribute__ ((interrupt, no_auto_psv)) _U2RXInterrupt(void);

void __attribute__ ((interrupt, no_auto_psv)) _U2TXInterrupt(void);

void __attribute__ ((interrupt, no_auto_psv)) _U3RXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _U3TXInterrupt(void); 					
void __attribute__ ((interrupt, no_auto_psv)) _U4RXInterrupt(void);
void __attribute__ ((interrupt, no_auto_psv)) _U4TXInterrupt(void);
void extUARTHdlr(unsigned char charIn);
void sendString (unsigned char myPort, char* myBuf);
void bputchar (unsigned char myPort, int myChar);
unsigned char toUpper(unsigned char inputChar);
void displayBanner(void);
void U1bputc(char c);
char U1bgetc(void);
void U2bputc(char c);
char U2bgetc(void);
void U3bputc(char c);
char U3bgetc(void);
void U4bputc(char c);
char U4bgetc(void);
void UExtbputc(char c);
char UExtbgetc(void);

extern unsigned char getU1RXCount(void);
extern unsigned char getU2RXCount(void);
extern unsigned char getU3RXCount(void);
extern unsigned char getU4RXCount(void);
extern unsigned char getExtRXCount(void);

extern unsigned char mySerialU1In[MAX_SERIAL_BUF_SIZE];
extern unsigned char mySerialU2In[MAX_SERIAL_BUF_SIZE];
extern unsigned char mySerialU3In[MAX_SERIAL_BUF_SIZE];
extern unsigned char mySerialU4In[MAX_SERIAL_BUF_SIZE];
extern unsigned char mySerialUExtIn[MAX_SERIAL_BUF_SIZE];

extern unsigned char mySerialU1Pos;
extern unsigned char mySerialU2Pos;
extern unsigned char mySerialU3Pos;
extern unsigned char mySerialU4Pos;
extern unsigned char mySerialUExtPos;





